#include <ruby.h>
#include <stdlib.h>
#include "distance_min_est_tag_1.h"

static VALUE id_hash1;

static int debug_flag = 0;

static VALUE
distance_min_est_tag_1_index(VALUE self,
			     VALUE context1,VALUE context2,VALUE pl_both) {
    int index1 = FIX2INT(rb_funcall(context1,id_hash1,0));
    int index2 = FIX2INT(rb_funcall(context2,id_hash1,0));
    int r;
    if (pl_both == Qfalse || pl_both == Qnil) {
	r = distance_min_est_tag_1_false_table[index1][index2];
    } else {
	r = distance_min_est_tag_1_true_table[index1][index2];
    }
    if (debug_flag)
	fputc(',',stderr);
    
    return INT2FIX(r);
}

void Init_context_sub_impl() {
    VALUE cContext = rb_eval_string("Context");
    rb_define_singleton_method(cContext, "distance_min_est_tag_1_index",
			       distance_min_est_tag_1_index, 3);
    id_hash1 = rb_intern("hash1");
    if (getenv("MORO_TEST_CONTEXT_SUB_IMPL") != NULL) {
	debug_flag = 1;
	fprintf(stderr, "Init_context_sub_impl called.\n");
    }
}
