# $Id: sorted_array.rb,v 1.1 2001/07/28 20:49:49 moro Exp $

class SortedArray
    include Enumerable
    
    def initialize
	@ary = []
    end

    def [](idx)
	@ary[idx]
    end

    def delete_at(idx)
	@ary.delete_at(idx)
    end

    def delete_if(&block)
	@ary.delete_if(&block)
    end

    def delete(val)
	@ary.delete(val)
    end

    def each(&block)
	@ary.each(&block)
    end

    def add(val)
	sz = @ary.size
	if sz == 0
	    @ary << val
	else
	    _add(val,0,sz-1)
	end
	self
    end

    def get_min
	@ary.shift
    end
    alias shift get_min

    def get_max
	@ary.pop
    end
    alias pop get_max

    def peek_min
	@ary[0]
    end

    def peek_max
	@ary[-1]
    end

    def size
	@ary.size
    end

    def empty?
	@ary.empty?
    end

    def index(val)
	sz = @ary.size
	if sz == 0
	    nil
	else
	    if idx = _index(val,0,sz-1)
		val_i = nil

		i = idx
		i_min = nil
		begin
		    val_i = @ary[i]
		    i_min = i if val == val_i
		    i -= 1
		end while ((val <=> val_i) == 0)
		return i_min if i_min

		i = idx
		begin
		    val_i = @ary[i]
		    return i if val == val_i
		    i += 1
		end while ((val <=> val_i) == 0)

		nil
	    else
		nil
	    end
	end
    end

    def to_a
	@ary.dup
    end

    ####################################################################
    private

    def _index(val,idx1,idx2)
	val1 = @ary[idx1]
	case val <=> val1
	when -1			# val < val1
	    return nil
	when 0
	    return idx1
	end

	val2 = @ary[idx2]
	case val <=> val2
	when 1			# val > val2
	    return nil
	when 0
	    return idx2
	end

	idx3 = (idx1+idx2)/2
	val3 = @ary[idx3]
	case (val <=> val3)
	when 0
	    return idx3
	when -1			# val < val3
	    return _index(val,idx1,idx3)
	when 1			# val > val3
	    return _index(val,idx3+1,idx2)
	else
	    raise "invalid <=> result: #{val <=> val3}"
	end
    end

    def _add(val,idx1,idx2)
	#print "_add: #{val}, #{idx1}(#{@ary[idx1]}), #{idx2}(#{@ary[idx2]})\n"

	val1 = @ary[idx1]
	if val <= val1
	    _insert(idx1,val)
	    return
	end
	    
	val2 = @ary[idx2]
	if val >= val2
	    _insert(idx2+1,val)
	    return
	end

	idx3 = (idx1+idx2)/2
	val3 = @ary[idx3]
	case (val <=> val3)
	when 0
	    _insert(idx3, val)
	when -1			# val < val3
	    _add(val,idx1,idx3)
	when 1
	    _add(val,idx3+1,idx2)
	else
	    raise "invalid <=> result: #{val <=> val3}"
	end
    end

    def _insert(idx,val)
	#print "_insert: #{idx}, #{val}\n"
	@ary[idx,0] = [val]
    end
end
