# StrIO - string buffer IO class
# written by MOROHOSHI Akihiko <moro@nii.ac.jp>
# $Id: str_io.rb,v 1.2 2001/07/29 13:18:20 moro Exp $

class StrIO
    def initialize
	@buf = []
	@str = nil
    end
    def print (*args)
	@buf << args.to_s.freeze
	@str = nil
    end
    def _print_no_to_s (*args)
	@buf << args.freeze
	@str = nil
    end
    def to_s
	if @str
	    @str
	else
	    @str = @buf.join('').freeze
	    @buf = [@str]
	end
	@str
    end
    def to_str
	to_s
    end
    def each(&blk)
	to_s.scan(/.*?\n/, &blk)
    end
end

class ArrayIO < StrIO
    alias print _print_no_to_s
    public :print
    def to_a
	@buf.dup
    end
end
